import 'dart:async';

import 'package:flutter/services.dart';

class ApexFlutterPlugin {
//  static void registerWith(Registrar registrar) {
//    final MethodChannel channel = MethodChannel('apex_flutter_plugin',
//        const StandardMethodCodec(), registrar.messenger);
//    final ApexFlutterPlugin instance = ApexFlutterPlugin();
//    channel.setMethodCallHandler(instance.handleMethodCall);
//  }
//
//  Future<dynamic> handleMethodCall(MethodCall call) async {
//    switch (call.method) {
//      case 'launch':
//        final String url = call.arguments['url'];
//        break;
//      default:
//        throw PlatformException(
//            code: 'Unimplemented',
//            details: "The url_launcher plugin for web doesn't implement "
//                "the method '${call.method}'");
//    }
//  }

  static MethodChannel _channel = MethodChannel('apex_flutter_plugin');

  /// Android/iOS
  /// Generate random uuid v4
  static Future<String?> generateRandomUuid() async {
    return (await _channel.invokeMethod('generateRandomUuid')) as String;
  }

  /// Android
  /// Build fingerprint of device
  /// Return null on ios or permission deny
  static Future<String?> fingerprint() async {
    return (await _channel.invokeMethod('getFingerprint')) as String;
  }

  /// Android
  /// hashUID is hash of (androidId + fingerprint)
  /// Return null on ios or permission deny
  static Future<String?> hashUID() async {
    return (await _channel.invokeMethod('hashUID')) as String;
  }

  /// Android
  /// androidID of device
  /// Return null on ios or permission deny
  static Future<String?> androidId() async {
    return (await _channel.invokeMethod('getAndroidId')) as String;
  }

  static Future<bool?> setSecureSurfaceView() async {
    return (await _channel.invokeMethod('setSecureSurfaceView') as bool);
  }
}
